
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "qpid/management/ManagementAgent.h"
#include "EventFull.h"

using namespace qmf::com::redhat::rhm::store;
using namespace qpid::framing;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           std::string;

string  EventFull::packageName  = string ("com.redhat.rhm.store");
string  EventFull::eventName    = string ("full");
uint8_t EventFull::md5Sum[16]   =
    {0x23,0x4c,0x70,0xc1,0xb0,0xeb,0x4e,0x5d,0x72,0x37,0x56,0x60,0xc3,0x10,0x78,0x68};

EventFull::EventFull (const std::string& _jrnlId,
        const std::string& _what) :
    jrnlId(_jrnlId),
    what(_what)
{}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
}

void EventFull::registerSelf(ManagementAgent* agent)
{
    agent->registerEvent(packageName, eventName, md5Sum, writeSchema);
}

void EventFull::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_EVENT);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (eventName);   // Event Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putOctet       (0);           // No Superclass    
    buf.putShort       (2); // Argument Count

    // Arguments
    ft.clear();
    ft.setString (NAME,    "jrnlId");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DESC,    "Journal Id");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,    "what");
    ft.setInt    (TYPE,    TYPE_SSTR);
    ft.setString (DESC,    "Description of event");
    buf.put (ft);


}

void EventFull::encode(::qpid::framing::Buffer& buf) const
{
    buf.putShortString(jrnlId);
    buf.putShortString(what);

}
